﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;

namespace PropertyInfoDataProvider
{
    class PropertyInformation : IPropertyInformation
    {
        public string PropertyName { get; private set; }
        public string MapiName { get; private set; }
        public string Description { get; private set; }
        public ushort PropertyId { get; private set; }
        public string DataType { get; private set; }
        public string MsdnLink { get; private set; }

        public PropertyInformation(TblProperty property)
        {
            PropertyName = property.Canonical_Name;
            MapiName = property.MAPI_Name;
            Description = property.Description;
            PropertyId = (ushort)property.Property_ID;
            DataType = property.Data_Type;
            MsdnLink = property.URI;
        }
    }
}
